using Knots;
using FastEndpoints;
using FastEndpoints.Swagger;

WebApplicationBuilder builder = WebApplication.CreateBuilder(args);

// On ajoute ici la configuration de la base de données
builder.Services.AddDbContext<KnotsDbContext>();

//On ajoute le CORS au code
builder.Services.AddCors(options =>
{ options.AddDefaultPolicy(policyBuilder =>
    {
        policyBuilder
            .WithOrigins("http://localhost:4200")
            .WithMethods("GET", "POST", "PUT", "PATCH", "DELETE")
            .AllowAnyHeader();
    });
});

// On construit l'application en lui donnant vie
WebApplication app = builder.Build();
app.UseAuthentication()
    .UseAuthorization()
    .UseFastEndpoints(options => 
        { 
            options.Endpoints.RoutePrefix = "API";
            options.Endpoints.ShortNames = true;
        }
    ).UseSwaggerGen();

app.UseHttpsRedirection();

app.UseCors();

app.Run();